package com.hikcreate.tocc_camera_receive;

import com.alibaba.fastjson.JSONObject;
import com.hikvision.artemis.sdk.ArtemisHttpUtil;
import com.hikvision.artemis.sdk.config.ArtemisConfig;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.ParseException;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

@SpringBootApplication
@EnableScheduling
public class ToccCameraReceiveApplication {

//    private static String subUrl ;
//    private static String unSubUrl = "https://10.15.16.150:60443/api/eventService/v1/eventUnSubscriptionByEventTypes";
//    private static ArrayList<String> subParams = new ArrayList<>();
    private static String ipAndPort ;

    public static void main(String[] args) {
//        subUrl= args[0];   // https://10.15.16.150:60443/api/eventService/v1/eventSubscriptionByEventTypes
        ipAndPort =args[0];// ip:port 10.11.57.109:60033

        SpringApplication.run(ToccCameraReceiveApplication.class, args);
    }

    @Scheduled(fixedRate =1000*60*10) //30000
    public static void doPost() {
            ArtemisConfig.host = "10.15.16.150:60443";// 代理API网关nginx服务器ip端口
            ArtemisConfig.appKey = "21306706";// 秘钥appkey
            ArtemisConfig.appSecret = "CAiyW1w8RCUpDXPqS2hu";// 秘钥appSecret

        /**
         * 能力开放平台的网站路径
         * TODO 路径不用修改，就是/artemis
         */
        final String ARTEMIS_PATH = "/artemis";
        //取消订阅
        final String unSubscribeApi = ARTEMIS_PATH +"/api/eventService/v1/eventUnSubscriptionByEventTypes";
        Map<String, String> unSubscribePath = new HashMap<String, String>(2) {
            {
                put("https://", unSubscribeApi);//根据现场环境部署确认是http还是https
            }
        };
        final String unSubBody = "{\"eventTypes\":[131616,131676]}";
        String unSubResult =ArtemisHttpUtil.doPostStringArtemis(unSubscribePath,unSubBody,null,null,"application/json",null);
        System.out.println("取消订阅："+unSubResult);
        //订阅
        final String getCamsApi = ARTEMIS_PATH +"/api/eventService/v1/eventSubscriptionByEventTypes";
        Map<String, String> path = new HashMap<String, String>(2) {
            {
                put("https://", getCamsApi);//根据现场环境部署确认是http还是https
            }
        };

        String body1= "{\"eventTypes\":[131676],\"eventDest\":\"http://"+ipAndPort+"/passengerRcv\"}".replaceAll(" ","");
        String result1 =ArtemisHttpUtil.doPostStringArtemis(path,body1,null,null,"application/json",null);// post请求application/json类型参数
        System.out.println(result1);
        String body2 = "{\"eventTypes\": [131616],\"eventDest\": \"http://"+ipAndPort+"/regionalPopulationRcv\"}".replaceAll(" ","");
        String result2 =ArtemisHttpUtil.doPostStringArtemis(path,body2,null,null,"application/json",null);// post请求application/json类型参数
        System.out.println(result2);

        //return result;
    }
}
