package com.hikcreate.tocc_camera_receive.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hikcreate.tocc_camera_receive.bean.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author ：heguantao
 * @date ：Created in 2021/1/12 11:02
 * @description：
 * @modified By：
 * @version: $
 */
@RestController
public class CameraDataController{
    private static Logger log = LoggerFactory.getLogger(CameraDataController.class);

    @RequestMapping("passengerRcv")
    public String receivePassengerRcv(@RequestBody String item) {

        //log.info("1==" + item);
        ResponseData response = new ResponseData();

        if (item != "" && item != null) {
            try {
                item = item.replaceAll(" ", "");
                ReceiveBean receiveBean = JSONObject.parseObject(item, ReceiveBean.class);
                String params = receiveBean.getParams();
                ParamsBean paramsBean = JSONObject.parseObject(params, ParamsBean.class);

                String events = paramsBean.getEvents();
                if (events != null && !events.equals("")) {
                    List<EventBean> eventBeans = JSONArray.parseArray(events, EventBean.class);
                    HashMap<String, String> map = new HashMap<>();
                    for (EventBean eventBean: eventBeans) {
                        map.put("eventType", eventBean.getEventType());
                        map.put("happenTime", eventBean.getHappenTime());
                        map.put("srcType", eventBean.getSrcType());
                        map.put("status", eventBean.getStatus());
                        map.put("timeout", eventBean.getTimeout());
                        String dataStr = eventBean.getData();
                        if (dataStr != null && !dataStr.equals("")){
                            DataBean dataBean = JSON.parseObject(dataStr, DataBean.class);
                            map.put("activePostCount", dataBean.getActivePostCount());
                            map.put("channelID", dataBean.getChannelID());
                            map.put("dataType", dataBean.getDataType());
                            map.put("eventState", dataBean.getEventState());
                            map.put("eventTypeName", dataBean.getEventType());
                            map.put("dateTime", dataBean.getDateTime());
                            map.put("recvTime", dataBean.getRecvTime());
                            map.put("sendTime", dataBean.getSendTime());
                            String framesPeopleCountingStr = dataBean.getFramesPeopleCounting();
                            if (framesPeopleCountingStr != null && !framesPeopleCountingStr.equals("")){
                                FramesPeopleCountingBean framesPeopleCountingBean = JSON.parseObject(framesPeopleCountingStr, FramesPeopleCountingBean.class);
                                map.put("framesPeopleCountingNum", framesPeopleCountingBean.getFramesPeopleCountingNum());
                            }
                            String targetAttrsStr = dataBean.getTargetAttrs();
                            if (targetAttrsStr != null && !targetAttrsStr.equals("")){
                                TargetAttrsBean targetAttrsBean = JSON.parseObject(targetAttrsStr, TargetAttrsBean.class);
                                map.put("cameraIndexCode", targetAttrsBean.getCameraIndexCode());
                                map.put("deviceId", targetAttrsBean.getDeviceId());
                            }
                        }
                        log.info(JSON.toJSONString(map));
                    }
                }
                return response.setCode("200").setMsg("接收数据成功！").toString();
            }catch (Exception e){
                e.printStackTrace();
                return response.setCode("100").setMsg("解析json错误！").toString();
            }
        }

        return response.setCode("100").setMsg("接收数据为空！").toString();
    }

    @RequestMapping("regionalPopulationRcv")
    public String receiveRegionalPopulation(@RequestBody String item) {
        ResponseData response = new ResponseData();
        //log.info("2==" + item);

        item = item.replaceAll(" ", "");
        if (!item.equals("")) {
            try {
                ReceiveBean receiveBean = JSON.parseObject(item, ReceiveBean.class);
                String params = receiveBean.getParams();
                ParamsBean paramsBean = JSON.parseObject(params, ParamsBean.class);
                String events = paramsBean.getEvents();
                if (events != null && !events.equals("")) {
                    List<EventBean> eventBeans = JSONArray.parseArray(events, EventBean.class);
                    if (eventBeans != null && eventBeans.size() > 0) {
                        Map<String, String> map = new HashMap<>();
                        for (EventBean eventBean : eventBeans) {
                            map.put("eventType", eventBean.getEventType());
                            map.put("happenTime", eventBean.getHappenTime());
                            map.put("srcType", eventBean.getSrcType());
                            map.put("status", eventBean.getStatus());
                            map.put("timeout", eventBean.getTimeout());
                            String dataStr = eventBean.getData();
                            if (dataStr != null && !dataStr.equals("")) {
                                RegionData regionData = JSON.parseObject(dataStr, RegionData.class);
                                map.put("activePostCount", regionData.getActivePostCount());
                                map.put("channelID", regionData.getChannelID());
                                map.put("dataType", regionData.getDataType());
                                map.put("dateTime", regionData.getDateTime());
                                map.put("eventState", regionData.getEventState());
                                map.put("eventTypeName", regionData.getEventType());
                                map.put("recvTime", regionData.getRecvTime());
                                map.put("sendTime", regionData.getSendTime());
                                String peopleCountingStr = regionData.getPeopleCounting();
                                if (peopleCountingStr != null && peopleCountingStr != "") {
                                    List<PeopleCountingBean> peopleCountingBeans = JSONArray.parseArray(peopleCountingStr, PeopleCountingBean.class);
                                    if (peopleCountingBeans != null && peopleCountingBeans.size() > 0) {
                                        for (PeopleCountingBean peopleCountingBean : peopleCountingBeans) {
                                            map.put("enter", peopleCountingBean.getEnter());
                                            map.put("exit", peopleCountingBean.getExit());
                                            map.put("pass", peopleCountingBean.getPass());
                                            String targetAttrs = peopleCountingBean.getTargetAttrs();
                                            if (targetAttrs != null && targetAttrs != "") {
                                                TargetAttrsBean targetAttrsBean = JSON.parseObject(targetAttrs, TargetAttrsBean.class);
                                                map.put("cameraIndexCode", targetAttrsBean.getCameraIndexCode());
                                                map.put("deviceId", targetAttrsBean.getDeviceId());
                                                map.put("deviceIndexCode", targetAttrsBean.getDeviceIndexCode());
                                            }

                                            log.info(JSON.toJSONString(map));
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                return response.setCode("200").setMsg("接收数据成功！").toString();
            } catch (Exception e) {
                e.printStackTrace();
                return response.setCode("100").setMsg("解析json错误！").toString();
            }
        }
        return response.setCode("100").setMsg("接收数据为空！").toString();
    }
}
